---
title: PerformanceFrameTiming
slug: Web/API/PerformanceFrameTiming
tags:
  - API
  - Frame Timing API
  - Interface
  - Performance Timeline API
  - PerformanceFrameTiming
  - Reference
  - Web Performance
---
<div>{{APIRef("Frame Timing API")}}{{SeeCompatTable}}</div>

<div><span class="seoSummary"><strong><code>PerformanceFrameTiming</code></strong> is an <em>abstract</em> interface that provides <em>frame</em> timing data about the browser's event loop.</span> A <em>frame</em> represents the amount of work a browser does in <a href="https://html.spec.whatwg.org/multipage/webappapis.html#processing-model-8">one event loop</a> such as processing DOM events, resizing, scrolling, rendering, CSS animations, etc.. A <em>frame rate</em> of 60fps (frames per second) for a 60Hz refresh rate is the target for a good <em>responsive</em> user experience. This means the browser should process a frame in about 16.7ms.</div>

<p>An application can register a {{domxref("PerformanceObserver")}} for "<code>frame</code>" {{domxref("PerformanceEntry","performance entry types")}} and the observer can retrieve data about the duration of each frame event. This information can be used to help identify areas that take too long to provide a good user experience.</p>

<p>{{InheritanceDiagram}}</p>

<h2 id="Properties">Properties</h2>

<p>This interface has no properties but it extends the following {{domxref("PerformanceEntry")}} properties (for "<code>frame</code>" {{domxref ("PerformanceEntry.entryType","performance entry types")}}) by qualifying and constraining the properties as follows:</p>

<dl>
 <dt>{{domxref("PerformanceEntry.entryType")}}</dt>
 <dd>Returns "<code>frame</code>".</dd>
 <dt>{{domxref("PerformanceEntry.name")}}</dt>
 <dd>Returns the <a href="https://dom.spec.whatwg.org/#concept-document-url">document's address</a>.</dd>
 <dt>{{domxref("PerformanceEntry.startTime")}}</dt>
 <dd>Returns the {{domxref("DOMHighResTimeStamp","timestamp")}} when the frame was started.</dd>
 <dt>{{domxref("PerformanceEntry.duration")}}</dt>
 <dd>Returns a {{domxref("DOMHighResTimeStamp","timestamp")}} indicating the difference between the <code>startTime</code>s of two successive frames.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>This interface has no methods.</p>

<h2 id="Example">Example</h2>

<p>See the example in <a href="/Web/API/Frame_Timing_API/Using_the_Frame_Timing_API">Using the Frame Timing API</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Frame Timing', '#performanceframetiming-interface', 'PerformanceFrameTiming')}}</td>
   <td>{{Spec2('Frame Timing')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PerformanceFrameTiming")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("PerformanceObserver")}}</li>
 <li><a href="/docs/Tools/Performance/Frame_rate">Frame Rate (Firefox Performance Tool)</a></li>
 <li><a href="/Web/API/Frame_Timing">Frame Timing (Overview)</a></li>
 <li><a href="/Web/API/Frame_Timing_API/Using_the_Frame_Timing_API">Using the Frame Timing API</a></li>
</ul>
